/*
 * Swagger Basket
 *
 * Корзина товаров
 *
 * The version of the OpenAPI document: 1.0.0
 *
 * Generated by: https://openapi-generator.tech
 */

using System.ComponentModel.DataAnnotations;
using System.Runtime.Serialization;
using System.Text;
using Newtonsoft.Json;

namespace BasketApp.Api.Adapters.Http.Contract.src.OpenApi.Models;

/// <summary>
/// </summary>
[DataContract]
public class ExistedItem : IEquatable<ExistedItem>
{
    /// <summary>
    ///     Идентификатор товара
    /// </summary>
    /// <value>Идентификатор товара</value>
    [Required]
    [DataMember(Name = "goodId", EmitDefaultValue = true)]
    public Guid GoodId { get; set; }

    /// <summary>
    ///     Количество
    /// </summary>
    /// <value>Количество</value>
    [Required]
    [DataMember(Name = "quantity", EmitDefaultValue = true)]
    public int Quantity { get; set; }

    /// <summary>
    ///     Идентификатор
    /// </summary>
    /// <value>Идентификатор</value>
    [DataMember(Name = "Id", EmitDefaultValue = true)]
    public Guid Id { get; set; }

    /// <summary>
    ///     Returns true if ExistedItem instances are equal
    /// </summary>
    /// <param name="other">Instance of ExistedItem to be compared</param>
    /// <returns>Boolean</returns>
    public bool Equals(ExistedItem other)
    {
        if (other is null) return false;
        if (ReferenceEquals(this, other)) return true;

        return
            (
                GoodId == other.GoodId ||
                GoodId.Equals(other.GoodId)
            ) &&
            (
                Quantity == other.Quantity ||
                Quantity.Equals(other.Quantity)
            ) &&
            (
                Id == other.Id ||
                Id.Equals(other.Id)
            );
    }

    /// <summary>
    ///     Returns the string presentation of the object
    /// </summary>
    /// <returns>String presentation of the object</returns>
    public override string ToString()
    {
        var sb = new StringBuilder();
        sb.Append("class ExistedItem {\n");
        sb.Append("  GoodId: ").Append(GoodId).Append("\n");
        sb.Append("  Quantity: ").Append(Quantity).Append("\n");
        sb.Append("  Id: ").Append(Id).Append("\n");
        sb.Append("}\n");
        return sb.ToString();
    }

    /// <summary>
    ///     Returns the JSON string presentation of the object
    /// </summary>
    /// <returns>JSON string presentation of the object</returns>
    public string ToJson()
    {
        return JsonConvert.SerializeObject(this, Formatting.Indented);
    }

    /// <summary>
    ///     Returns true if objects are equal
    /// </summary>
    /// <param name="obj">Object to be compared</param>
    /// <returns>Boolean</returns>
    public override bool Equals(object obj)
    {
        if (obj is null) return false;
        if (ReferenceEquals(this, obj)) return true;
        return obj.GetType() == GetType() && Equals((ExistedItem)obj);
    }

    /// <summary>
    ///     Gets the hash code
    /// </summary>
    /// <returns>Hash code</returns>
    public override int GetHashCode()
    {
        unchecked // Overflow is fine, just wrap
        {
            var hashCode = 41;
            // Suitable nullity checks etc, of course :)

            hashCode = hashCode * 59 + GoodId.GetHashCode();

            hashCode = hashCode * 59 + Quantity.GetHashCode();

            hashCode = hashCode * 59 + Id.GetHashCode();
            return hashCode;
        }
    }

    #region Operators

#pragma warning disable 1591

    public static bool operator ==(ExistedItem left, ExistedItem right)
    {
        return Equals(left, right);
    }

    public static bool operator !=(ExistedItem left, ExistedItem right)
    {
        return !Equals(left, right);
    }

#pragma warning restore 1591

    #endregion Operators
}